package ru.ulstu.extractor.markup.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PostMapping;
import ru.ulstu.extractor.core.Route;
import ru.ulstu.extractor.markup.model.MarkupForm;
import ru.ulstu.extractor.markup.model.MarkupRow;
import ru.ulstu.extractor.markup.service.MarkupService;
import ru.ulstu.extractor.ts.model.TimeSeries;
import ru.ulstu.extractor.ts.service.TimeSeriesService;
import springfox.documentation.annotations.ApiIgnore;

import java.util.List;
import java.util.stream.Collectors;

@Controller
@ApiIgnore
public class TimeSeriesMarkupController {
    private final TimeSeriesService timeSeriesService;
    private final MarkupService markupService;

    public TimeSeriesMarkupController(TimeSeriesService timeSeriesService,
                                      MarkupService markupService) {
        this.timeSeriesService = timeSeriesService;
        this.markupService = markupService;
    }

    @GetMapping("time-series-markup")
    public String markupTs(Model model) {
        List<TimeSeries> tss = timeSeriesService.getAllTimeSeries();
        model.addAttribute("markupForm", new MarkupForm(tss.stream().map(MarkupRow::new).collect(Collectors.toList())));
        return "markup";
    }

    @PostMapping(Route.ADD_MARKUP)
    public String addMarkups(@ModelAttribute MarkupForm markupForm) {
        markupService.saveMarkup(markupForm);
        return "markup";
    }
}
